package cn.nosum.demo.mvc.action;

import cn.nosum.demo.service.IModifyService;
import cn.nosum.demo.service.IQueryService;
import cn.nosum.framework.annotation.Autowired;
import cn.nosum.framework.annotation.Controller;
import cn.nosum.framework.annotation.RequestMapping;
import cn.nosum.framework.annotation.RequestParam;
import cn.nosum.framework.mvc.v4.servlet.ModelAndView;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@Controller
@RequestMapping("/web")
public class MyAction {

	@Autowired
	private IQueryService queryService;
	@Autowired
	private IModifyService modifyService;

	@RequestMapping("/query.json")
	public ModelAndView query(HttpServletRequest request, HttpServletResponse response,
							  @RequestParam("name") String name){
		String result = queryService.query(name);
		return out(response,result);
	}
	
	@RequestMapping("/add*.json")
	public ModelAndView add(HttpServletRequest request,HttpServletResponse response,
							@RequestParam("name") String name,@RequestParam("addr") String addr){
		String result = modifyService.add(name,addr);
		Map<String,String> model=new HashMap<String, String>();
		model.put("result",result);
		return new ModelAndView("",model);
	}
	
	@RequestMapping("/remove.json")
	public ModelAndView remove(HttpServletRequest request, HttpServletResponse response,
							   @RequestParam("id") Integer id){
		String result = modifyService.remove(id);
		return out(response,result);
	}
	
	@RequestMapping("/edit.json")
	public ModelAndView edit(HttpServletRequest request,HttpServletResponse response,
							 @RequestParam("id") Integer id, @RequestParam("name") String name){
		String result = modifyService.edit(id,name);
		return out(response,result);
	}

	private ModelAndView out(HttpServletResponse resp,String str){
		try {
			resp.getWriter().write(str);
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
}
